#
# Conditional build:
%bcond_without	static	# build without dar_static
#
Summary:	dar makes backup of a directory tree and files
Summary(pl):	dar - narzdzie do tworzenia kopii zapasowych drzew katalogw i plikw
Name:		dar
Version:	2.1.0
Release:	0.2
License:	GPL v2
Group:		Applications
Source0:	http://dl.sourceforge.net/%{name}/%{name}-%{version}.tar.gz
# Source0-md5:	4cf38abcf6c7e39722b7c8654630192a
Patch0:		%{name}-opt.patch
URL:		http://dar.linux.free.fr/
BuildRequires:	attr-devel
BuildRequires:	autoconf >= 2.59
BuildRequires:	automake
BuildRequires:	bzip2-devel
%ifarch alpha
# ICE in 3.3.x up to 3.3.2 - require patched version
BuildRequires:	gcc-c++ >= 5:3.3.2-0.3
%endif
BuildRequires:	libstdc++-devel
BuildRequires:	libtool >= 2:1.4d
BuildRequires:	zlib-devel
%if %{with static}
BuildRequires:	attr-static
BuildRequires:	bzip2-static
BuildRequires:	glibc-static
BuildRequires:	libstdc++-static
BuildRequires:	zlib-static
%endif
Requires:	%{name}-libs = %{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
dar is a shell command, that makes backup of a directory tree and
files.

FILTERS: dar is able to backup from total file system to a single
file. Additionally a mechanism of filters permits, based on the
filename, to exclude or include some files while backing up or
restoring a directory tree. In the other side, a secondary filter
mechanism permits to exclude some branches of a directory tree, or to
only include some branches.

DIFFERENTIAL BACKUP: When making a backup with dar, you have the
possibility to make a full backup or a differential backup. A full
backup, as expected makes backup of all files as specified on the
command line (with or without filters). Instead, a differential
backup, (over filter mechanism), saves only files that have changed
since a given reference backup. Additionally, files that existed in
the reference backup and which do no more exist at the time of the
differential backup are recorded in the backup. At recovery time,
(unless you deactivate it), restoring a differential backup will
update changed files and new files, but also remove files that have
been recorded as deleted. Note that the reference backup can be a full
backup or another differential backup. This way you can make a first
full backup, then many differential backup, each taking as reference
the last backup made.

SLICES: Dar stands for Disk ARchive. From the beginning it was
designed to be able to split an archive over several removable media
whatever their number is and whatever their size is. Thus dar is able
to save over old floppy disk, CD-R, DVD-R, CD-RW, DVD-RW, Zip, Jazz,
etc... Dar is not concerned by un/mounting a removable medium, instead
it is independent of hardware. Given the size, it will split the
archive in several files (called SLICES), eventually pausing before
creating the next one, allowing this way, the user to un/mount a
medium, burn the file on CD-R, send it by email (if your mail system
does not allow huge file in emails, dar can help you here also). By
default, (no size specified), dar will make one slice whatever its
size is. Additionally, the size of the first slice can be specified
separately, if for example you want first to fulfil a partially filled
disk before starting using empty ones. Last, at restoration time, dar
will just pause and prompt the user asking a slice only if it is
missing.

COMPRESSION: last, dar can use compression. By default no compression
is used. Actually only gzip algorithm is implemented, but some room
has been done for bzip2 and any other compression algorithm. Note
that, compression is made before slices, which means that using
compression with slices, will not make slices smaller, but will
probably make less slices in the backup.

DIRECT ACCESS: even using compression dar has not to read the whole
backup to extract one file. This way if you just want to restore one
file from a huge backup, the process will be much faster than using
tar. Dar first reads the catalogue (i.e. the contents of the backup),
then it goes directly to the location of the saved file(s) you want to
restore and proceed to restoration. In particular using slices dar
will ask only for the slice(s) containing the file(s) to restore.

HARD LINK CONSIDERATION: hard links are now properly saved. They are
properly restored if possible. If for example restoring across a
mounted filesystem, hard linking will fail, but dar will then
duplicate the inode and file content, issuing a warning.

EXTENDED ATTRIBUTES: support for extended attributes have to be
activated at compilation time (see INSTALL). Dar is able to save and
restore EA, all or just those of a given namespace (system or user).
If no EA have been saved and restoration occurs over a file that has
EA, they will be preserved. But if they have been saved empty for a
given file, any existing EA for that file will be removed at
restoration time, unless -u and/or -U is given on command-line.

ARCHIVE TESTING thanks to CRC (cyclic redundancy checks), dar is able
to detect data corruption in the archive. Only the file where data
corruption occurred will not be possible to restore, but dar will
restore the other even when compression is used.

USING PIPES dar is now able to produce an archive to its standard
output or named pipe. it is also able to read an archive through a
pair of pipes, to take a remote archive as reference, or even to
restore data from a remote archive. This way it is now possible to
store an archive remotely and in total security (if using encrypted
means)

ISOLATION the catalogue (i.e.: the contents of an archive), can be
extracted (this operation is called isolation) to a small file, that
can in turn be used as reference for differential archive. There is no
more need to provide an archive to be able to create a differential
backup over it, just its catalogue is necessary.

RE-SHAPE SLICES OF AN EXISTING ARCHIVE the external program named
"dar_xform" is able to change the size of slices of a given archive.
The resulting archive is totally identical to archives directly
created by dar. Source archive can be taken from a set of slice, from
standard input or even a named pipe.

%description -l pl
dar jest poleceniem powoki, ktre tworzy kopie zapasowe drzew
katalogw i plikw. Moliwoci:
- Filtry: dar moe tworzy kopi zapasow caego systemu plikw do
  pojedynczego pliku; mechanizm filtrw pozwala wycza lub docza
  pliki przy tworzeniu kopii lub odtwarzaniu z niej.
- Backup rnicowy: dar moe tworzy kopie pene lub rnicowe
  (zawierajce tylko te pliki, ktre zmieniy si od innego backupu)
- Czci (slices): dar oznacza "Disk ARchive". Od pocztku ma
  moliwo dzielenia archiww na rne noniki wymienialne,
  niezalenie od ich liczby i rozmiaru (mona tworzy kopie na CD-R,
  DVD-R, CD-RW, Zip, Jazz...).
- Kompresja: domylnie dar nie kompresuje danych; ma zaimplementowany
  algorytm gzip, jest przygotowywany do bzip2 i innych. Kompresja jest
  wykonywana przed podziaem na czci.
- Bezporedni dostp: nawet w przypadku uycia kompresji, dar nie musi
  czyta caej kopii aby odtworzy jeden plik. Najpierw odczytuje
  katalog, nastpnie skacze od razu do waciwego miejsca.
- Obsuga twardych dowiza: dar zachowuje i odtwarza je w miar
  moliwoci; w przypadku niemoliwoci wykonania dowizania, powiela
  plik i wypisuje ostrzeenie.
- Obsuga rozszerzonych atrybutw (zalenie od opcji kompilacji): dar
  potrafi zachowywa i odtwarza rozszerzone atrubuty - wszystkie lub
  tylko dotyczce danej przestrzeni nazw (systemowej lub uytkownika).
- Testowanie archiww: dziki uyciu CRC dar wykrywa uszkodzone dane;
  tylko uszkodzone pliki nie zostan odtworzone, reszta tak - nawet w
  przypadku uycia kompresji.
- Uycie rurek - dar moe wyprodukowa archiwum na standardowe wyjcie
  lub do nazwanej rurki. Moe take czyta archiwum z pary rurek, a
  nawet odtwarza ze zdalnego archiwum.
- Rozdzielenie: katalog (zawarto archiwum) moe by wycignity do
  maego pliku, ktry moe by uywany jako odniesienie dla
  rnicowego backupu.
- Przeksztacanie czci istniejcego archiwum: zewntrzny program o
  nazwie dar_xform jest w stanie zmienia rozmiary czci podanego
  archiwum. Moe czyta z zestawu katakw, standardowego wejcia lub
  nazwanej rurki.

%package static
Summary:	Static version of dar backup tool
Summary(pl):	Statyczna wersja archiwizatora dar
Group:		Applications

%description static
Static version of dar backup tool.

%description static -l pl
Statyczna wersja archiwizatora dar.

%package libs
Summary:	Shared version of dar library
Summary(pl):	Wspdzielona wersja biblioteki dar
Group:          Libraries

%description libs
Shared version of dar library.

%description libs -l pl
Wspdzielona wersja biblioteki dar.

%package devel
Summary:        Header files to develop dar software
Summary(pl):    Pliki nagwkowe biblioteki dar
Group:          Development/Libraries
Requires:       %{name}-libs = %{version}-%{release}

%description devel
Header files to develop software which operates on dar.

%description devel -l pl
Pliki nagwkowe potrzebne do rozwoju oprogramowania korzystajcego z
dara.

%package libs-static
Summary:	Static version of dar library
Summary(pl):	Statyczna wersja biblioteki dar
Group:          Development/Libraries
Requires:       %{name}-devel = %{version}-%{release}

%description libs-static
Static version of dar library.

%description libs-static -l pl
Statyczna wersja biblioteki dar.

%prep
%setup -q
%patch -p1

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--enable-ea-support \
%{?without_static:--disable-dar-static} \
	--disable-upx
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{?with_static:install -d $RPM_BUILD_ROOT/bin}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%{?with_static:mv -f $RPM_BUILD_ROOT{%{_bindir},/bin}/dar_static}

find $RPM_BUILD_DIR/%{name}-%{version}/doc -name "Makefile*" | xargs rm -fv

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc BUGS README TODO doc
%attr(755,root,root) %{_bindir}/*
%{_datadir}/%{name}
%{_mandir}/man1/*

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libdar.so.*.*.*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libdar.so
%{_libdir}/libdar.la
%{_includedir}/dar

%if %{with static}
%files static
%defattr(644,root,root,755)
%attr(755,root,root) /bin/*
%endif

%files libs-static
%defattr(644,root,root,755)
%{_libdir}/libdar.a
